source: installer/opengnsys_update.sh @ 1616b6e

918-git-images-111dconfigfileconfigure-oglivegit-imageslgromero-new-oglivemainmaint-cronmount-efivarfsmultivmmultivm-ogboot-installerogClonningEngineogboot-installer-jenkinsoglive-ipv6test-python-scriptsticket-301ticket-50ticket-50-oldticket-577ticket-585ticket-611ticket-612ticket-693ticket-700ubu24tplunification2use-local-agent-oglivevarios-instalacionwebconsole3
Last change on this file since 1616b6e was fe293a7, checked in by adv <adv@…>, 14 years ago

branch version 1.0 ticket #420 #439 #429 boot-tools iso

git-svn-id: https://opengnsys.es/svn/branches/version1.0@2304 a21b9725-9963-47de-94b9-378ad31fedc9

  • Property mode set to 100755
File size: 21.0 KB
RevLine 
[a0867b37]1#!/bin/bash
2#/**
3#@file    opengnsys_update.sh
4#@brief   Script actualización de OpenGnSys
5#@warning No se actualiza BD, ni ficheros de configuración.
6#@version 0.9 - basado en opengnsys_installer.sh
7#@author  Ramón Gómez - ETSII Univ. Sevilla
8#@date    2010/01/27
[c1e00e4]9#@version 1.0 - adaptación a OpenGnSys 1.0
10#@author  Ramón Gómez - ETSII Univ. Sevilla
11#@date    2011/03/02
[64dd765]12#@version 1.0.1 - control de auto actualización del script
13#@author  Ramón Gómez - ETSII Univ. Sevilla
14#@date    2011/05/17
[a0867b37]15#*/
16
17
[295b4ab]18####  AVISO: Editar configuración de acceso por defecto a la Base de Datos.
19OPENGNSYS_DATABASE="ogAdmBD"            # Nombre de la base datos
20OPENGNSYS_DBUSER="usuog"                # Usuario de acceso
21OPENGNSYS_DBPASSWORD="passusuog"        # Clave del usuario
22
23####  AVISO: NO Editar variables de acceso desde el cliente
24OPENGNSYS_CLIENTUSER="opengnsys"        # Usuario Samba
25
26
[a0867b37]27# Sólo ejecutable por usuario root
28if [ "$(whoami)" != 'root' ]
29then
30        echo "ERROR: this program must run under root privileges!!"
31        exit 1
32fi
[4e51cb0]33# Error si OpenGnSys no está instalado (no existe el directorio del proyecto)
34INSTALL_TARGET=/opt/opengnsys
35if [ ! -d $INSTALL_TARGET ]; then
36        echo "ERROR: OpenGnSys is not installed, cannot update!!"
37        exit 1
38fi
[a0867b37]39
40# Comprobar si se ha descargado el paquete comprimido (USESVN=0) o sólo el instalador (USESVN=1).
41PROGRAMDIR=$(readlink -e $(dirname "$0"))
[64dd765]42PROGRAMNAME=$(basename "$0")
[c1e00e4]43DEPS="build-essential g++-multilib rsync ctorrent samba unzip netpipes debootstrap schroot squashfs-tools"
[07c3a59]44OPENGNSYS_SERVER="www.opengnsys.es"
[a0867b37]45if [ -d "$PROGRAMDIR/../installer" ]; then
46    USESVN=0
47else
48    USESVN=1
49    DEPS="$DEPS subversion"
50fi
[eb9424f]51SVN_URL="http://$OPENGNSYS_SERVER/svn/branches/version1.0/"
[a0867b37]52
53WORKDIR=/tmp/opengnsys_update
54mkdir -p $WORKDIR
55
56LOG_FILE=/tmp/opengnsys_update.log
57
58
59
60#####################################################################
61####### Algunas funciones útiles de propósito general:
62#####################################################################
[295b4ab]63
[64dd765]64# Comprobar auto-actualización.
65function checkAutoUpdate()
66{
67        local update=0
68
69        # Actaulizar el script si ha cambiado o no existe el original.
70        if [ $USESVN -eq 1 ]; then
[7b0c6ff]71                svn export $SVN_URL/installer/$PROGRAMNAME
[64dd765]72                if ! diff --brief $PROGRAMNAME $INSTALL_TARGET/lib/$PROGRAMNAME &>/dev/null || ! test -f $INSTALL_TARGET/lib/$PROGRAMNAME; then
73                        mv $PROGRAMNAME $INSTALL_TARGET/lib
74                        update=1
75                else
76                        rm -f $PROGRAMNAME
77                fi
78        else
79                if ! diff --brief $PROGRAMDIR/$PROGRAMNAME $INSTALL_TARGET/lib/$PROGRAMNAME &>/dev/null || ! test -f $INSTALL_TARGET/lib/$PROGRAMNAME; then
80                        cp -a $PROGRAMDIR/$PROGRAMNAME $INSTALL_TARGET/lib
81                        update=1
82                fi
83        fi
84
85        return $update
86}
87
88
[a0867b37]89function getDateTime()
90{
[5eb61a6]91        date "+%Y%m%d-%H%M%S"
[a0867b37]92}
93
94# Escribe a fichero y muestra por pantalla
95function echoAndLog()
96{
[5eb61a6]97        echo $1
98        DATETIME==`getDateTime`
99        echo "$DATETIME=;$SSH_CLIENT;$1" >> $LOG_FILE
[a0867b37]100}
101
102function errorAndLog()
103{
[5eb61a6]104        echo "ERROR: $1"
105        DATETIME=`getDateTime`
106        echo "$DATETIME=;$SSH_CLIENT;ERROR: $1" >> $LOG_FILE
[a0867b37]107}
108
109
110#####################################################################
111####### Funciones de copia de seguridad y restauración de ficheros
112#####################################################################
113
114# Hace un backup del fichero pasado por parámetro
115# deja un -last y uno para el día
116function backupFile()
117{
118        if [ $# -ne 1 ]; then
119                errorAndLog "${FUNCNAME}(): invalid number of parameters"
120                exit 1
121        fi
122
123        local fichero=$1
124        local fecha=`date +%Y%m%d`
125
126        if [ ! -f $fichero ]; then
127                errorAndLog "${FUNCNAME}(): file $fichero doesn't exists"
128                return 1
129        fi
130
[ebbbfc01]131        echoAndLog "${FUNCNAME}(): Making $fichero back-up"
[a0867b37]132
133        # realiza una copia de la última configuración como last
134        cp -p $fichero "${fichero}-LAST"
135
136        # si para el día no hay backup lo hace, sino no
137        if [ ! -f "${fichero}-${fecha}" ]; then
138                cp -p $fichero "${fichero}-${fecha}"
139        fi
140}
141
142# Restaura un fichero desde su copia de seguridad
143function restoreFile()
144{
145        if [ $# -ne 1 ]; then
146                errorAndLog "${FUNCNAME}(): invalid number of parameters"
147                exit 1
148        fi
149
150        local fichero=$1
151
[ebbbfc01]152        echoAndLog "${FUNCNAME}(): restoring file $fichero"
[a0867b37]153        if [ -f "${fichero}-LAST" ]; then
154                cp -p "$fichero-LAST" "$fichero"
155        fi
156}
157
158
159#####################################################################
[295b4ab]160####### Funciones de acceso a base de datos
161#####################################################################
162
163# Actualizar la base datos
164function importSqlFile()
165{
166        if [ $# -ne 4 ]; then
167                errorAndLog "${FNCNAME}(): invalid number of parameters"
168                exit 1
169        fi
170
171        local dbuser="$1"
172        local dbpassword="$2"
173        local database="$3"
174        local sqlfile="$4"
175        local tmpfile=$(mktemp)
176        local status
177
178        if [ ! -r $sqlfile ]; then
179                errorAndLog "${FUNCNAME}(): Unable to read $sqlfile!!"
180                return 1
181        fi
182
183        echoAndLog "${FUNCNAME}(): importing SQL file to ${database}..."
184        chmod 600 $tmpfile
185        sed -e "s/SERVERIP/$SERVERIP/g" -e "s/DBUSER/$OPENGNSYS_DB_USER/g" \
186            -e "s/DBPASSWORD/$OPENGNSYS_DB_PASSWD/g" $sqlfile > $tmpfile
187        mysql -u$dbuser -p"$dbpassword" --default-character-set=utf8 "$database" < $tmpfile
188        status=$?
189        rm -f $tmpfile
190        if [ $status -ne 0 ]; then
191                errorAndLog "${FUNCNAME}(): error importing $sqlfile in database $database"
192                return 1
193        fi
194        echoAndLog "${FUNCNAME}(): file imported to database $database"
195        return 0
196}
197
198
199#####################################################################
[a0867b37]200####### Funciones de instalación de paquetes
201#####################################################################
202
203# Instalar las deependencias necesarias para el actualizador.
[64dd765]204function installDependencies()
[a0867b37]205{
206        if [ $# = 0 ]; then
207                echoAndLog "${FUNCNAME}(): no deps needed."
[c1e00e4]208        else
209                while [ $# -gt 0 ]; do
[ebbbfc01]210                        dpkg -s $1 2>/dev/null | grep -q "Status: install ok"
[c1e00e4]211                        if [ $? -ne 0 ]; then
212                                INSTALLDEPS="$INSTALLDEPS $1"
213                        fi
214                        shift
215                done
216                if [ -n "$INSTALLDEPS" ]; then
[ebbbfc01]217                        apt-get update && apt-get -y install --force-yes $INSTALLDEPS
[c1e00e4]218                        if [ $? -ne 0 ]; then
219                                errorAndLog "${FUNCNAME}(): cannot install some dependencies: $INSTALLDEPS."
220                                return 1
221                        fi
222                fi
223        fi
[a0867b37]224}
225
226
227#####################################################################
228####### Funciones para el manejo de Subversion
229#####################################################################
230
231function svnExportCode()
232{
233        if [ $# -ne 1 ]; then
234                errorAndLog "${FUNCNAME}(): invalid number of parameters"
235                exit 1
236        fi
237
[27dc5ff]238        local url="$1"
[a0867b37]239
240        echoAndLog "${FUNCNAME}(): downloading subversion code..."
241
[7ad4465]242        svn checkout "${url}" opengnsys
[a0867b37]243        if [ $? -ne 0 ]; then
244                errorAndLog "${FUNCNAME}(): error getting code from ${url}, verify your user and password"
245                return 1
246        fi
247        echoAndLog "${FUNCNAME}(): subversion code downloaded"
248        return 0
249}
250
251
252############################################################
253###  Detectar red
254############################################################
255
[07c3a59]256# Comprobar si existe conexión.
257function checkNetworkConnection()
258{
259        OPENGNSYS_SERVER=${OPENGNSYS_SERVER:-"www.opengnsys.es"}
260        wget --spider -q $OPENGNSYS_SERVER
261}
262
[a0867b37]263
264#####################################################################
265####### Funciones específicas de la instalación de Opengnsys
266#####################################################################
267
[cf2142ea]268# Copiar ficheros de arranque de los servicios del sistema de OpenGnSys
[64dd765]269function updateServicesStart()
270{
[51b179a]271        echoAndLog "${FUNCNAME}(): Updating OpenGnSys init file ..."
[6b65dfd]272        cp -p $WORKDIR/opengnsys/admin/Sources/Services/opengnsys.init /etc/init.d/opengnsys
[cf2142ea]273        if [ $? != 0 ]; then
274                errorAndLog "${FUNCNAME}(): Error updating /etc/init.d/opengnsys"
275                exit 1
276        fi
[51b179a]277        echoAndLog "${FUNCNAME}(): init file updated successfully."
[cf2142ea]278}
279
[45f1fe8]280# Actualizar cliente OpenGnSys
[295b4ab]281function updateClientFiles()
[45f1fe8]282{
283        echoAndLog "${FUNCNAME}(): Updating OpenGnSys Client files."
284        rsync --exclude .svn -irplt $WORKDIR/opengnsys/client/shared/* $INSTALL_TARGET/client
285        if [ $? -ne 0 ]; then
286                errorAndLog "${FUNCNAME}(): error while updating client structure"
[51b179a]287                exit 1
[45f1fe8]288        fi
289        find $INSTALL_TARGET/client -name .svn -type d -exec rm -fr {} \; 2>/dev/null
290       
291        echoAndLog "${FUNCNAME}(): Updating OpenGnSys Cloning Engine files."
[51b179a]292        rsync --exclude .svn -irplt $WORKDIR/opengnsys/client/engine/*.lib* $INSTALL_TARGET/client/lib/engine/bin
[45f1fe8]293        if [ $? -ne 0 ]; then
294                errorAndLog "${FUNCNAME}(): error while updating engine files"
[51b179a]295                exit 1
[45f1fe8]296        fi
297       
[51b179a]298        echoAndLog "${FUNCNAME}(): client files update success."
[45f1fe8]299}
[4e51cb0]300
301# Exportar nombre de usuario y grupo del servicio Apache.
302function getApacheUser()
303{
304        # Variables de ejecución de Apache
305        # - APACHE_RUN_USER
306        # - APACHE_RUN_GROUP
307        if [ -f /etc/apache2/envvars ]; then
308                source /etc/apache2/envvars
309        fi
310        APACHE_RUN_USER=${APACHE_RUN_USER:-"www-data"}
311        APACHE_RUN_GROUP=${APACHE_RUN_GROUP:-"www-data"}
312}
313
[a0867b37]314# Copiar ficheros del OpenGnSys Web Console.
315function updateWebFiles()
316{
[d655cc4]317        local ERRCODE
[a0867b37]318        echoAndLog "${FUNCNAME}(): Updating web files..."
[d655cc4]319        backupFile $INSTALL_TARGET/www/controlacceso.php
320        mv $INSTALL_TARGET/www $INSTALL_TARGET/WebConsole
[1db2ed8]321        rsync --exclude .svn -irplt $WORKDIR/opengnsys/admin/WebConsole $INSTALL_TARGET
[d655cc4]322        ERRCODE=$?
323        mv $INSTALL_TARGET/WebConsole $INSTALL_TARGET/www
[c1e00e4]324        unzip -o $WORKDIR/opengnsys/admin/xajax_0.5_standard.zip -d $INSTALL_TARGET/www/xajax
[d655cc4]325        if [ $ERRCODE != 0 ]; then
[a0867b37]326                errorAndLog "${FUNCNAME}(): Error updating web files."
327                exit 1
328        fi
[d655cc4]329        restoreFile $INSTALL_TARGET/www/controlacceso.php
[a0867b37]330        # Cambiar permisos para ficheros especiales.
[ebbbfc01]331        chown -R $APACHE_RUN_USER:$APACHE_RUN_GROUP $INSTALL_TARGET/www/includes $INSTALL_TARGET/www/images/iconos
[a0867b37]332        echoAndLog "${FUNCNAME}(): Web files updated successfully."
333}
334
[72134d5]335# Copiar carpeta de Interface
[64dd765]336function updateInterfaceAdm()
[72134d5]337{
[27dc5ff]338        local errcode=0
[72134d5]339         
340        # Crear carpeta y copiar Interface
341        echoAndLog "${FUNCNAME}(): Copying Administration Interface Folder"
342        mv $INSTALL_TARGET/client/interfaceAdm $INSTALL_TARGET/client/Interface
343        rsync --exclude .svn -irplt $WORKDIR/opengnsys/admin/Interface $INSTALL_TARGET/client
[27dc5ff]344        errcoce=$?
[72134d5]345        mv $INSTALL_TARGET/client/Interface $INSTALL_TARGET/client/interfaceAdm
[27dc5ff]346        if [ $errcode -ne 0 ]; then
[72134d5]347                echoAndLog "${FUNCNAME}(): error while updating admin interface"
348                exit 1
349        fi
350        chmod -R +x $INSTALL_TARGET/client/interfaceAdm
[b6f1726]351        chown $OPENGNSYS_CLIENTUSER:$OPENGNSYS_CLIENTUSER $INSTALL_TARGET/client/interfaceAdm/CambiarAcceso
[f6c1d2b]352        chmod 700 $INSTALL_TARGET/client/interfaceAdm/CambiarAcceso
[72134d5]353        echoAndLog "${FUNCNAME}(): Admin interface updated successfully."
354}
[a0867b37]355
[5d6bf97]356# Crear documentación Doxygen para la consola web.
357function makeDoxygenFiles()
358{
359        echoAndLog "${FUNCNAME}(): Making Doxygen web files..."
360        $WORKDIR/opengnsys/installer/ogGenerateDoc.sh \
361                        $WORKDIR/opengnsys/client/engine $INSTALL_TARGET/www
362        if [ ! -d "$INSTALL_TARGET/www/html" ]; then
363                errorAndLog "${FUNCNAME}(): unable to create Doxygen web files."
364                return 1
365        fi
[45f1fe8]366        rm -fr "$INSTALL_TARGET/www/api"
[15b2a4e]367        mv "$INSTALL_TARGET/www/html" "$INSTALL_TARGET/www/api"
368        rm -fr $INSTALL_TARGET/www/{man,perlmod,rtf}
[5d6bf97]369        chown -R $APACHE_RUN_USER:$APACHE_RUN_GROUP $INSTALL_TARGET/www/api
370        echoAndLog "${FUNCNAME}(): Doxygen web files created successfully."
371}
372
373
[a0867b37]374# Crea la estructura base de la instalación de opengnsys
375function createDirs()
376{
[eb9424f]377        # Crear estructura de directorios.
[a0867b37]378        echoAndLog "${FUNCNAME}(): creating directory paths in ${INSTALL_TARGET}"
[cfad47b]379        mkdir -p ${INSTALL_TARGET}/{bin,doc,etc,lib,sbin,www}
380        mkdir -p ${INSTALL_TARGET}/{client,images}
[a0867b37]381        mkdir -p ${INSTALL_TARGET}/log/clients
[eb9424f]382        ln -fs ${INSTALL_TARGET}/log /var/log/opengnsys
[a0867b37]383        ln -fs /var/lib/tftpboot ${INSTALL_TARGET}
[cfad47b]384        mkdir -p ${INSTALL_TARGET}/tftpboot/{pxelinux.cfg,menu.lst}
[a0867b37]385        if [ $? -ne 0 ]; then
386                errorAndLog "${FUNCNAME}(): error while creating dirs. Do you have write permissions?"
387                return 1
388        fi
389
[eb9424f]390        # Crear usuario ficticio.
391        if id -u $OPENGNSYS_CLIENTUSER &>/dev/null; then
392                echoAndLog "${FUNCNAME}(): user \"$OPENGNSYS_CLIENTUSER\" is already created"
393        else
394                echoAndLog "${FUNCNAME}(): creating OpenGnSys user"
395                useradd $OPENGNSYS_CLIENTUSER 2>/dev/null
396                if [ $? -ne 0 ]; then
397                        errorAndLog "${FUNCNAME}(): error creating OpenGnSys user"
398                        return 1
399                fi
400        fi
401
402        # Establecer los permisos básicos.
403        echoAndLog "${FUNCNAME}(): setting directory permissions"
[cfad47b]404        chmod -R 775 $INSTALL_TARGET/{log/clients,images,tftpboot/pxelinux.cfg,tftpboot/menu.lst}
405        chown -R :$OPENGNSYS_CLIENTUSER $INSTALL_TARGET/{log/clients,images,tftpboot/pxelinux.cfg,tftpboot/menu.lst}
[eb9424f]406        if [ $? -ne 0 ]; then
407                errorAndLog "${FUNCNAME}(): error while setting permissions"
408                return 1
409        fi
410
[a0867b37]411        echoAndLog "${FUNCNAME}(): directory paths created"
412        return 0
413}
414
415# Copia ficheros de configuración y ejecutables genéricos del servidor.
[64dd765]416function updateServerFiles()
[bb30a50]417{
[c1e00e4]418        # No copiar ficheros del antiguo cliente Initrd
[873cf1e]419        local SOURCES=( repoman/bin \
[c1e00e4]420                        server/bin \
[873cf1e]421                        server/tftpboot \
[bb30a50]422                        installer/opengnsys_uninstall.sh \
[873cf1e]423                        doc )
424        local TARGETS=( bin \
425                        bin \
426                        tftpboot \
[4057c5d]427                        lib/opengnsys_uninstall.sh \
[873cf1e]428                        doc )
[a0867b37]429
430        if [ ${#SOURCES[@]} != ${#TARGETS[@]} ]; then
431                errorAndLog "${FUNCNAME}(): inconsistent number of array items"
432                exit 1
433        fi
434
435        echoAndLog "${FUNCNAME}(): updating files in server directories"
436        pushd $WORKDIR/opengnsys >/dev/null
437        local i
438        for (( i = 0; i < ${#SOURCES[@]}; i++ )); do
[27dc5ff]439                if [ -d "$INSTALL_TARGET/${TARGETS[i]}" ]; then
[4057c5d]440                        rsync --exclude .svn -irplt "${SOURCES[i]}" $(dirname $(readlink -e "$INSTALL_TARGET/${TARGETS[i]}"))
[aa36857]441                else
[4057c5d]442                        rsync --exclude .svn -irplt "${SOURCES[i]}" $(readlink -e "$INSTALL_TARGET/${TARGETS[i]}")
[aa36857]443                fi
[a0867b37]444        done
445        popd >/dev/null
[9ee62ad]446        echoAndLog "${FUNCNAME}(): updating cron files"
447        echo "* * * * *   root   [ -x $INSTALL_TARGET/bin/torrent-creator ] && $INSTALL_TARGET/bin/torrent-creator" > /etc/cron.d/torrentcreator
[da8db11]448        echoAndLog "${FUNCNAME}(): server files updated successfully."
[a0867b37]449}
450
451####################################################################
452### Funciones de compilación de código fuente de servicios
453####################################################################
454
[bb30a50]455# Recompilar y actualiza los serivicios y clientes.
[64dd765]456function compileServices()
[a0867b37]457{
[bb30a50]458        local hayErrores=0
459
460        # Compilar OpenGnSys Server
461        echoAndLog "${FUNCNAME}(): Recompiling OpenGnSys Admin Server"
462        pushd $WORKDIR/opengnsys/admin/Sources/Services/ogAdmServer
463        make && mv ogAdmServer $INSTALL_TARGET/sbin
464        if [ $? -ne 0 ]; then
465                echoAndLog "${FUNCNAME}(): error while compiling OpenGnSys Admin Server"
466                hayErrores=1
467        fi
468        popd
469        # Compilar OpenGnSys Repository Manager
470        echoAndLog "${FUNCNAME}(): Recompiling OpenGnSys Repository Manager"
471        pushd $WORKDIR/opengnsys/admin/Sources/Services/ogAdmRepo
472        make && mv ogAdmRepo $INSTALL_TARGET/sbin
473        if [ $? -ne 0 ]; then
474                echoAndLog "${FUNCNAME}(): error while compiling OpenGnSys Repository Manager"
475                hayErrores=1
476        fi
477        popd
478        # Compilar OpenGnSys Agent
479        echoAndLog "${FUNCNAME}(): Recompiling OpenGnSys Agent"
480        pushd $WORKDIR/opengnsys/admin/Sources/Services/ogAdmAgent
481        make && mv ogAdmAgent $INSTALL_TARGET/sbin
482        if [ $? -ne 0 ]; then
483                echoAndLog "${FUNCNAME}(): error while compiling OpenGnSys Agent"
484                hayErrores=1
485        fi
486        popd
487
[a0867b37]488        # Compilar OpenGnSys Client
[bb30a50]489        echoAndLog "${FUNCNAME}(): Recompiling OpenGnSys Client"
[72134d5]490        pushd $WORKDIR/opengnsys/admin/Sources/Clients/ogAdmClient
[e473667]491        make && mv ogAdmClient $INSTALL_TARGET/client/bin
[a0867b37]492        if [ $? -ne 0 ]; then
493                echoAndLog "${FUNCNAME}(): error while compiling OpenGnSys Client"
494                hayErrores=1
495        fi
496        popd
497
498        return $hayErrores
499}
500
501
502####################################################################
[4e51cb0]503### Funciones instalacion cliente OpenGnSys
[a0867b37]504####################################################################
505
[c1e00e4]506# Actualizar nuevo cliente para OpenGnSys 1.0
507function updateClient()
508{
[d168a46]509        local DOWNLOADURL="http://www.opengnsys.es/downloads"
[fe293a7]510        local FILENAME=ogLive-natty-2.6.38-8-generic-pae-r2303.iso
[0b85cc93]511        local SOURCEFILE=$DOWNLOADURL/$FILENAME
512        local TARGETFILE=$INSTALL_TARGET/lib/$FILENAME
513        local SOURCELENGTH
514        local TARGETLENGTH
515        local TMPDIR=/tmp/${FILENAME%.iso}
[a63345ac]516        local OGINITRD=$INSTALL_TARGET/tftpboot/ogclient/oginitrd.img
517        local SAMBAPASS
[0b85cc93]518
519        # Comprobar si debe actualizarse el cliente.
[c3cc6b0]520        SOURCELENGTH=$(LANG=C wget --spider $SOURCEFILE 2>&1 | awk '/Length:/ {print $2}')
[d168a46]521        TARGETLENGTH=$(ls -l $TARGETFILE 2>/dev/null | awk '{print $5}')
[d4e90c1]522        [ -z $TARGETLENGTH ] && TARGETLENGTH=0
[0b85cc93]523        if [ "$SOURCELENGTH" != "$TARGETLENGTH" ]; then
524                echoAndLog "${FUNCNAME}(): Loading Client"
525                wget $DOWNLOADURL/$FILENAME -O $TARGETFILE
526                if [ ! -s $TARGETFILE ]; then
527                        errorAndLog "${FUNCNAME}(): Error loading OpenGnSys Client"
528                        return 1
529                fi
[a63345ac]530                # Obtener la clave actual de acceso a Samba para restaurarla.
531                if [ -f $OGINITRD ]; then
532                        SAMBAPASS=$(gzip -dc $OGINITRD | \
533                                    cpio -i --to-stdout scripts/ogfunctions 2>&1 | \
[c3cc6b0]534                                    grep "^[    ]*OPTIONS=" | \
[a63345ac]535                                    sed 's/\(.*\)pass=\(\w*\)\(.*\)/\2/')
536                fi
537                # Montar la imagen ISO del ogclient, actualizar ficheros y desmontar.
538                echoAndLog "${FUNCNAME}(): Updatting ogclient files"
539                mkdir -p $TMPDIR
540                mount -o loop,ro $TARGETFILE $TMPDIR
541                rsync -irlt $TMPDIR/ogclient $INSTALL_TARGET/tftpboot
542                umount $TMPDIR
543                rmdir $TMPDIR
544                # Recuperar la clave de acceso a Samba.
545                if [ -n "$SAMBAPASS" ]; then
546                        echoAndLog "${FUNCNAME}(): Restoring client access key"
547                        echo -ne "$SAMBAPASS\n$SAMBAPASS\n" | \
548                                        $INSTALL_TARGET/bin/setsmbpass
549                fi
550                # Establecer los permisos.
551                find -L $INSTALL_TARGET/tftpboot -type d -exec chmod 755 {} \;
552                find -L $INSTALL_TARGET/tftpboot -type f -exec chmod 644 {} \;
553                chown -R :$OPENGNSYS_CLIENTUSER $INSTALL_TARGET/tftpboot/ogclient
554                chown -R $APACHE_RUN_USER:$APACHE_RUN_GROUP $INSTALL_TARGET/tftpboot/{menu.lst,pxelinux.cfg}
[e1c01217]555               
556                cp -prv $INSTALL_TARGET/tftpboot/ogclient/ogvmlinuz* $INSTALL_TARGET/tftpboot/
557                cp -prv $INSTALL_TARGET/tftpboot/ogclient/oginitrd.img* $INSTALL_TARGET/tftpboot/
558               
[a63345ac]559                echoAndLog "${FUNCNAME}(): Client update successfully"
[0b85cc93]560        else
[a63345ac]561                echoAndLog "${FUNCNAME}(): Client is already updated"
[c1e00e4]562        fi
563}
[a0867b37]564
[eb9424f]565# Resumen de actualización.
566function updateSummary()
567{
568        # Actualizar fichero de versión y revisión.
569        local VERSIONFILE="$INSTALL_TARGET/doc/VERSION.txt"
570        local REVISION=$(LANG=C svn info $SVN_URL|awk '/Revision:/ {print "r"$2}')
571
572        [ -f $VERSIONFILE ] || echo "OpenGnSys" >$VERSIONFILE
573        perl -pi -e "s/($| r[0-9]*)/ $REVISION/" $VERSIONFILE
574
575        echo
576        echoAndLog "OpenGnSys Update Summary"
577        echo       "========================"
578        echoAndLog "Project version:                  $(cat $VERSIONFILE)"
579        echo
580}
581
582
[a0867b37]583
584#####################################################################
[3320409]585####### Proceso de actualización de OpenGnSys
[a0867b37]586#####################################################################
587
588
589echoAndLog "OpenGnSys update begins at $(date)"
590
[bb30a50]591pushd $WORKDIR
592
[27dc5ff]593# Comprobar si hay conexión y detectar parámetros de red por defecto.
594checkNetworkConnection
595if [ $? -ne 0 ]; then
596        errorAndLog "Error connecting to server. Causes:"
597        errorAndLog " - Network is unreachable, review devices parameters."
598        errorAndLog " - You are inside a private network, configure the proxy service."
599        errorAndLog " - Server is temporally down, try agian later."
600        exit 1
601fi
602
[64dd765]603# Comprobar auto-actualización del programa.
604if [ "$PROGRAMDIR" != "$INSTALL_TARGET/bin" ]; then
605        checkAutoUpdate
606        if [ $? -ne 0 ]; then
[f580c51]607                echoAndLog "OpenGnSys updater has been overwritten."
608                echoAndLog "Please, re-execute this script."
[64dd765]609                exit
610        fi
611fi
612
[bb30a50]613# Instalar dependencias.
[a0867b37]614installDependencies $DEPS
615if [ $? -ne 0 ]; then
616        errorAndLog "Error: you may install all needed dependencies."
617        exit 1
618fi
619
620# Arbol de directorios de OpenGnSys.
621createDirs ${INSTALL_TARGET}
622if [ $? -ne 0 ]; then
623        errorAndLog "Error while creating directory paths!"
624        exit 1
625fi
626
627# Si es necesario, descarga el repositorio de código en directorio temporal
628if [ $USESVN -eq 1 ]; then
629        svnExportCode $SVN_URL
630        if [ $? -ne 0 ]; then
631                errorAndLog "Error while getting code from svn"
632                exit 1
633        fi
634else
635        ln -fs "$(dirname $PROGRAMDIR)" opengnsys
636fi
637
[295b4ab]638# Si existe fichero de actualización de la base de datos; aplicar cambios.
639INSTVERSION=$(awk '{print $2}' $INSTALL_TARGET/doc/VERSION.txt)
640REPOVERSION=$(awk '{print $2}' $WORKDIR/opengnsys/doc/VERSION.txt)
641OPENGNSYS_DBUPDATEFILE="$WORKDIR/opengnsys/admin/Database/$OPENGNSYS_DATABASE-$INSTVERSION-$REPOVERSION.sql"
642if [ -f $OPENGNSYS_DBUPDATEFILE ]; then
643        echoAndLog "Updating tables from version $INSTVERSION to $REPOVERSION"
644        importSqlFile $OPENGNSYS_DBUSER $OPENGNSYS_DBPASSWORD $OPENGNSYS_DATABASE $OPENGNSYS_DBUPDATEFILE
645else
646        echoAndLog "Database unchanged."
647fi
648
649# Actualizar ficheros complementarios del servidor
[a0867b37]650updateServerFiles
651if [ $? -ne 0 ]; then
[da8db11]652        errorAndLog "Error updating OpenGnSys Server files"
[a0867b37]653        exit 1
654fi
655
[295b4ab]656# Actualizar ficheros del cliente
657updateClientFiles
658updateInterfaceAdm
[45f1fe8]659
[295b4ab]660# Actualizar páqinas web
[4e51cb0]661getApacheUser
[a0867b37]662updateWebFiles
663if [ $? -ne 0 ]; then
[da8db11]664        errorAndLog "Error updating OpenGnSys Web Admin files"
[a0867b37]665        exit 1
666fi
[5d6bf97]667# Generar páginas Doxygen para instalar en el web
668makeDoxygenFiles
[a0867b37]669
[bb30a50]670# Recompilar y actualizar los servicios del sistema
671compileServices
672
673# Actaulizar ficheros auxiliares del cliente
[a0867b37]674updateClient
675if [ $? -ne 0 ]; then
676        errorAndLog "Error updating clients"
677        exit 1
678fi
679
[95f1f68]680# Actualizamos el fichero que arranca los servicios de OpenGnSys
681updateServicesStart
682
[3320409]683# Eliminamos el fichero de estado del tracker porque es incompatible entre los distintos paquetes
[ebbbfc01]684if [ -f /tmp/dstate ]; then
685        rm -f /tmp/dstate
[3320409]686fi
687
[eb9424f]688# Mostrar resumen de actualización.
689updateSummary
690
[a0867b37]691#rm -rf $WORKDIR
692echoAndLog "OpenGnSys update finished at $(date)"
693
694popd
695
Note: See TracBrowser for help on using the repository browser.